<?php
namespace Teknisa\EST\Modules\Ajuste\Controllers;

use Teknisa\EST\Controllers\TeknisaCrud;
use \Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Filter;
use \Zeedhi\Framework\DTO\Response;
use \Zeedhi\Framework\DataSource\ParameterBag;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use \Teknisa\Libs\Service\CRUD;
use Zeedhi\Framework\DTO\Response\Error;


class Itlanctoest extends TeknisaCrud{
    protected $dataSourceName = 'itlanctoest';
    
    public function save(Request $request, Response $response) {
        try {
            $this->dataSourceName = 'itlanctoest';
            
            $row = $request->getRow();
            
            if($row['__is_new']){
                $newFilterCriteria = new FilterCriteria('itlanctoest');
                $newFilterCriteria->addCondition('CDFILIAL', $row['CDFILIAL']);
                $newFilterCriteria->addCondition('NRLANCESTQ', $row['NRLANCESTQ']);
                $newFilterCriteria->addCondition('CDPRODUTO', $row['CDPRODUTO']);
                
                $newFilterCriteria->addCondition('CDALMOXARIFE', $row['CDALMOXARIFE']?? ' ');
                $newFilterCriteria->addCondition('CDLOCALESTOQ', $row['CDLOCALESTOQ']?? ' ');
                $newFilterCriteria->addCondition('NRLOTEESTQ', $row['NRLOTEESTQ']?? ' ');
                $newFilterCriteria->addCondition('NRSUBLOTE', $row['NRSUBLOTE']?? ' ');
                
                $newFilterRequest = new Filter($newFilterCriteria,$request->getMethod(),'/itlanctoest/find',$request->getUserId());
                parent::find($newFilterRequest,$response);
                $dataset = $response->getDataSets();
                $rows = $dataset[0]->getRows();
                
                
                if(count($rows) > 0){
                    throw new \Exception("Protudo já cadastrado para este lançamento.");
                }
                    
            }
            
            parent::save($request,$response);
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}