<?php
namespace Geral\Entities;

class Tiporelacaval extends Base\Tiporelacaval
{
    public static function insert(
                            $nrtiporelacaval,    
                            $nravaliacao,   
                            $nrtiporelaciona,  
                            $vrpesorelacaval, 
                            $nrorg = 1,
                            $idativo = 's',
                            $dtinclusao,
                            $dtultatu = null,
                            $nrorginclusao = null, 
                            $cdoperinclusao = null,
                            $nrorgultatu = null,
                            $cdoperultatu = null){
        try {
            $obj = new self();

            $obj->setNrtiporelacaval(\Geral\Util\NovoCodigo::geraCodigo($nrtiporelacaval, 'TIPORELACAVAL',1,10,true));
            $obj->setNravaliacao($nravaliacao);
            $obj->setNrtiporelaciona($nrtiporelaciona);
            $obj->setVrpesorelacaval($vrpesorelacaval);
            $obj->setNrorg($nrorg);
            $obj->setIdativo($idativo);
            $obj->setDtinclusao($dtinclusao);
            $obj->setDtultatu($dtultatu);
            $obj->setNrorginclusao($nrorginclusao);
            $obj->setCdoperinclusao($cdoperinclusao);
            $obj->setNrorgultatu($nrorgultatu);
            $obj->setCdoperultatu($cdoperultatu);

            $obj->persist();

            \Setforms2\Shared\Registry::getEntityManager()->flush();

            return $obj;

        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

    public static function relacionamentosPesoDiferente ($params) {
        $sql = "SELECT
                  COUNT(1) AS CONTADOR
                FROM TIPORELACAVAL TP1
                JOIN TIPORELACAVAL TP2
                  ON TP2.NRAVALIACAO = :P_NRAVALIACAO
                 AND TP2.NRORG       = :P_NRORG
                 AND TP1.VRPESORELACAVAL != TP2.VRPESORELACAVAL
                WHERE TP1.NRORG       = :P_NRORG
                  AND TP1.NRAVALIACAO = :P_NRAVALIACAO
                HAVING COUNT(1) > 1";

        try {
            $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}